/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.DashboardConstants");

(function() {

/*
 * Dashboard constants.
 *
 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
 * future with minimal or no warning.
 * 
 * @since 0.6
 */
com.ibm.team.dashboard.web.ui.DashboardConstants = {

	/*
	 * Page action for viewing a dashboard.
	 */
	ACTION_VIEW_DASHBOARD: "com.ibm.team.dashboard.viewDashboard",

	/*
	 * Page action for viewing the all dashboards page.
	 */
	ACTION_VIEW_ALL_DASHBOARDS: "com.ibm.team.dashboard.viewAllDashboards",

	/*
	 * Page id of dashboards.
	 */
	PAGE_ID: "com.ibm.team.dashboard",

	/*
	 * Contributor or personal scope.
	 */
	SCOPE_CONTRIBUTOR: "CONTRIBUTOR",
	
	/*
	 * Team area scope.
	 */
	SCOPE_TEAM_AREA: "TEAM_AREA",
	
	/*
	 * Project area scope.
	 */
	SCOPE_PROJECT_AREA: "PROJECT_AREA",

	/*
	 * Dashboard URL parameter for specifying the item ID of the dashboard to
	 * open.
	 */	
	URL_PARAM_ID: "id",

	/*
	 * Dashboard URL parameter for specifying a team area name/path.
	 */	
	URL_PARAM_TEAM: "team",

	/*
	 * Dashboard URL parameter for specifying a project name.
	 */	
	URL_PARAM_PROJECT: "project",

	/*
	 * Dashboard URL parameter for specifying the tab ID of the dashboard to
	 * open.
	 */	
	URL_PARAM_TAB: "tab"
};
 
})();
