/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.jfs.web.ui.internal.JazzFoundationApplication"); //$NON-NLS-1$

dojo.require("jazz.app._JazzApplication"); //$NON-NLS-1$
dojo.require("com.ibm.team.jfs.web.ui.internal.RepositoryInitializer");
dojo.require("com.ibm.team.jfs.web.ui.internal.ProcessInitializer");
dojo.require("com.ibm.team.repository.web.ui.internal.Util");
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.jfs.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var messages = dojo.i18n.getLocalization("com.ibm.team.jfs.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
var Util = com.ibm.team.repository.web.ui.internal.Util;

dojo.declare("com.ibm.team.jfs.web.ui.internal.JazzFoundationApplication", jazz.app._JazzApplication, { //$NON-NLS-1$

	constructor: function(args) {
		com.ibm.team.jfs.web.ui.internal.RepositoryInitializer.init(this, "_onSuccess", "onFailure"); //initialize repo features
	
		//hardcode jazz.net footer links until branding solution is available.
		if (location.href.indexOf("jazz.net") > 0 && location.href.indexOf("localhost") > 0) {
			this.config.footer = {links: [ 
				{ label: messages.contact, href: "/legal/contact.jsp" },
				{ label: messages.termsOfUse, href: "/legal/terms.jsp" }
			]};
		}
	},
	
	_onSuccess: function() {
		try {
			var contexts = com.ibm.team.jfs.web.ui.internal.ProcessInitializer.init(this); //initialize project areas
			if (contexts && contexts.currentContext) {
				this.config.buttons.push({ //create the home button
					label: "Dashboards",
					iconSrc: this.productIconLarge,
					align: "left",
					pageId: "com.ibm.team.dashboard"
				});
			}	
			if (Util.userIsAdmin()) {
				var curUrl = new dojo._Url(location.href);
				var query = curUrl.query ? "?" + curUrl.query : "";
				var adminLink = {
					label: messages.admin,
					href: dojo.baseUrl + "../../admin" + query,
					align: "right"
				};
				if (this.config.contextSwitcher) {
					adminLink.rightPipe = true;
				}
				this.config.navbarItems.push(adminLink);
			}
		} catch(e) {
			this.onFailure(e);
			return;
		}
		this.start();
	}
});

})();
