/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojox.data.dom"); //$NON-NLS-1$
dojo.require("jazz.ui.internal.SimpleToolbar"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineTree"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineStore"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TimelineDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.IterationDialog"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;

(function(){

	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/TimelineEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		widgetsInTemplate: true,
		constructor: function(arg){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this._connectHandles = [];
			
			this._actionsBar = new jazz.ui.internal.SimpleToolbar({
				// From SimpleToolBar.js pending workitem 89577
				addButton: function(context, callback, args){
					//args: label, imgSrc, index
					if (!args.imgSrc) {
						console.error("Toolbar: No image URL passed. Skipping."); //$NON-NLS-1$
						return;
					}
					var button = document.createElement("a"); //$NON-NLS-1$
					button.className = "jazz-ui-SimpleToolbar-button" //$NON-NLS-1$
					button.href = "#"; //$NON-NLS-1$
					button.title = args.label;
					button.disabled = false;
					
					var img = document.createElement("img"); //$NON-NLS-1$
					img.src = args.imgSrc;
					img.alt = args.label;
					button.appendChild(img);
					
					if (callback) {
						this._events.push(dojo.connect(button, "onclick", button, function(event){ //$NON-NLS-1$
							dojo.stopEvent(event);
							if (this.disabled !== true) {
								dojo.hitch(context, callback)(event);
							}
						}));
					}
					try {
						return this._insert({
							domNode: button
						}, args.index);
					} finally {
						button = null;
						img = null;
					}
				},
				disableButton: function(widget, disable){
					if (widget && widget.domNode) {
						var button = widget.domNode;
						button.disabled = disable;
						if (disable) {
							// Remove href to eliminate tab stop to act disabled
							button.removeAttribute("href"); //$NON-NLS-1$
							dojo.addClass(button, "jazz-ui-SimpleToolbar-button-disabled") //$NON-NLS-1$
						} else {
							button.setAttribute("href", "#"); //$NON-NLS-1$ //$NON-NLS-2$
							dojo.removeClass(button, "jazz-ui-SimpleToolbar-button-disabled") //$NON-NLS-1$
						}
					}
					
				},
				uninitialize: function(){
					dojo.forEach(this._events, function(event){
						dojo.disconnect(event)
					})
					this.inherited(arguments);
					
				}
				
			});
			
			/*
			 This won't make it into 1.0.0.1
			 
			 this.actionsBar.addButton(this, this._handleShowArchivedClick, {
			 label: this.messages.TimelineEditor_ShowArchivedTooltip,
			 imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/milestone_archived_obj.gif") //$NON-NLS-1$ //$NON-NLS-2$
			 });
			 */
			this._currentIterationButton = this._actionsBar.addButton(this, this._handleSetCurrentIterationClick, {
				label: this.messages.TimelineEditor_SetCurrentIterationTooltip,
				imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/current_phase_co.gif") //$NON-NLS-1$ //$NON-NLS-2$
			});
			this._timelineButton = this._actionsBar.addButton(this, this._handleSetProjectTimeLineClick, {
				label: this.messages.TimelineEditor_SetProjectTimelineTooltip,
				imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/project_devline_co.gif") //$NON-NLS-1$ //$NON-NLS-2$
			});
			
			this.actionsBarDiv.appendChild(this._actionsBar.domNode);
			
			/*
			 This won't make it into 1.0.0.1
			 
			 this.actionsBar.addButton(this, this._handleMoveIterationClick, {
			 label: this.messages.TimelineEditor_MoveIterationTooltip,
			 imgSrc: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/synced.gif") //$NON-NLS-1$ //$NON-NLS-2$
			 });
			 */
			this.refresh();
		},
		
		startup: function(){
			var buttons = [this._editPropertiesButton, this._duplicateButton, this._createTimelineButton, this._createIterationButton, this._deleteButton];
			var width = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper.resizeI18NButtons(this.buttonColumn, buttons, undefined, 2.0);
			this.inherited(arguments);
			
			// Set the width of the button column sligtly larger than the buttons themselves
			this.buttonColumn.style.width = width + 5 + "em"; //$NON-NLS-1$		
		},
		
		refresh: function(){
			this._clearState();
			
			this._actionsBar.disableButton(this._timelineButton, true);
			this._actionsBar.disableButton(this._currentIterationButton, true);

			// Until we add archive support for pre-existing items
			// the delete button should start out disabled
			this._deleteButton.disabled = true;
			this._editPropertiesButton.disabled = true;
			
			this.editor.addSaveParticipant(this, "com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor"); //$NON-NLS-1$	
			this._timelineTree = this._createTimelineTree();
			dojox.data.dom.removeChildren(this.timelineTreeDiv);
			this.timelineTreeDiv.appendChild(this._timelineTree.domNode);
			
		},
		
		_clearState: function(){
			this.editor.removeSaveParticipant("com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor"); //$NON-NLS-1$	
			this._disconnectHandles();
			delete this._model;
			if (this._timelineTree) {
				this._timelineTree.destroyRecursive();
				delete this._timelineTree;
			}
			
		},
		
		changesPending: function(){
			return this._model.store.isDirty();
		},
		
		_createTimelineTree: function(){
		
			var store = this.editor._getProcessAreaStore();
			// Need to create a dummy pending node that
			// matches at least one item from the model's
			// query or it will not show it's nodes upon
			// load		
			store._createPendingItem();
			this._model = new com.ibm.team.process.web.ui.internal.admin.projects.TimelineModel({
				store: store
			});
			var self = this;
			var tree = new com.ibm.team.process.web.ui.internal.admin.projects.TimelineTree({
				model: this._model,
				editorContext: ProcessConstants.EditorContext.PROJECT,
				onClick: function(item, node){
					// Nothing to do yet on click
				},
				_focusChanged: function(node){
					self._deleteButton.disabled = !this.isNewItem(node.item);
					self._editPropertiesButton.disabled = false;
					self._createIterationButton.disabled = false;
					self._actionsBar.disableButton(self._timelineButton, !this.model.store.isTimeline(node.item) || this.model.store.isProjectTimeline(node.item));
					self._actionsBar.disableButton(self._currentIterationButton, !this.model.store.isIteration(node.item) || this.model.store.isCurrentIteration(node.item));
				}
			});
			store._deletePendingItem();
			return tree;
			
		},
		
		_handleEditPropertiesClick: function(event){
			dojo.stopEvent(event);
			var item = this._timelineTree.getFocusedItem();
			if (item !== null) {
				if (this._model.store.isTimeline(item)) {
					this._editTimeline(item);
				} else {
					this._editIteration(item);
				}
			}
			
		},
		
		_handleDuplicateClick: function(event){
			dojo.stopEvent(event);
			this.comingToAComputerNearYou();
			
		},
		
		_handleCreateIterationClick: function(event){
			dojo.stopEvent(event);
			
			var initialValues = [];
			initialValues.push(this.messages.IterationDialog_NewIterationDefaultId);
			initialValues.push(this.messages.IterationDialog_NewIterationDefaultName);
			initialValues.push(new Date());
			initialValues.push(ProcessConstants.EMPTY);
			
			var dialogWidget = this._createIterationDialog({
				timelineStore: this._timelineTree.model.store,
				initialValues: initialValues,
				hasDeliverable: true,
				isNewIteration: true,
				primaryTitle: this.messages.IterationDialog_CreateIterationTitle
			});
			var iterationDialog = dialogWidget.iterationDialog;
			var self = this;
			this._connectHandles.push(dojo.connect(iterationDialog.finishButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				var iteration = {
					id: iterationDialog.identifier.attr('value'), //$NON-NLS-1$
					name: iterationDialog.displayName.attr('value'), //$NON-NLS-1$
					startDate: iterationDialog.startDate.attr('value'), //$NON-NLS-1$
					endDate: iterationDialog.endDate.attr('value'), //$NON-NLS-1$
					hasDeliverable: iterationDialog.scheduledReleaseCheckbox.checked,
					iterationTypeItemId: iterationDialog.getSelectedIterationTypeId()
				};
				var newIteration = self._timelineTree.addNewIteration(iteration);
				self.editor.setDirty(self.editor.changesPending());
				this.close();
				self._timelineTree.focusItem(newIteration);
			}));
			
			iterationDialog.identifier.focus();
			
			
		},
		
		_editIteration: function(iterationToEdit){
			var store = this._timelineTree.model.store;
			var initialValues = [];
			initialValues.push(this._timelineTree.getIterationId(store.getValue(iterationToEdit, "contextId"))); //$NON-NLS-1$
			initialValues.push(store.getValue(iterationToEdit, "name")); //$NON-NLS-1$
			initialValues.push(store.getValue(iterationToEdit, "startDate")); //$NON-NLS-1$
			initialValues.push(store.getValue(iterationToEdit, "endDate")); //$NON-NLS-1$
			var dialogWidget = this._createIterationDialog({
				timelineStore: this._timelineTree.model.store,
				initialValues: initialValues,
				hasDeliverable: store.getValue(iterationToEdit, "hasDeliverable"), //$NON-NLS-1$
				iterationTypeItemId: store.getValue(iterationToEdit, "iterationTypeItemId"), //$NON-NLS-1$
				isNewIteration: false,
				primaryTitle: this.messages.IterationDialog_EditIterationTitle
			});
			var self = this;
			var iterationDialog = dialogWidget.iterationDialog;
			this._connectHandles.push(dojo.connect(iterationDialog.finishButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (iterationDialog.changesPending()) {
					self._timelineTree.updateIteration(iterationToEdit, {
						contextId: iterationDialog.identifier.attr('value'), //$NON-NLS-1$ //$NON-NLS-2$
						name: iterationDialog.displayName.attr('value'), //$NON-NLS-1$ //$NON-NLS-2$
						startDate: iterationDialog.startDate.attr('value'), //$NON-NLS-1$ //$NON-NLS-2$
						endDate: iterationDialog.endDate.attr('value'), //$NON-NLS-1$ //$NON-NLS-2$
						hasDeliverable: iterationDialog.scheduledReleaseCheckbox.checked,
						iterationTypeItemId: iterationDialog.getSelectedIterationTypeId()
					});
					self.editor.setDirty(self.editor.changesPending());
				}
				this.close();
				self._timelineTree.focusItem(iterationToEdit);
			}));
			
			if (!this._timelineTree.isNewItem(iterationToEdit)) {
				// Temporarily disabled on existing iterations until back end support
				// is added to make the changes in the config XML
				iterationDialog.identifier.attr('disabled', true); //$NON-NLS-1$
				iterationDialog.displayName.focus();
			} else {
				iterationDialog.identifier.focus();
			}
			
			
		},
		
		_handleDeleteClick: function(event){
			dojo.stopEvent(event);
			var itemToDelete = this._timelineTree.getFocusedItem();
			if (itemToDelete !== null) {
				var store = this._timelineTree.model.store;
				var label = this._timelineTree.getLabel(itemToDelete);
				var message = this.messages.TimelineEditor_DeleteTimelineConfirmationMessage;
				if (store.isIteration(itemToDelete)) {
					message = this.messages.TimelineEditor_DeleteIterationConfirmationMessage;
				}
				var question = dojo.string.substitute(message, [label]);
				if (confirm(question)) {
					this._timelineTree.deleteSelectedItem();
					this._deleteButton.disabled = true;
					this._editPropertiesButton.disabled = true;
					this._createIterationButton.disabled = true;
					this._deleteButton.blur();
				}
			}
		},
		
		_handleShowArchivedClick: function(event){
			dojo.stopEvent(event);
			this.comingToAComputerNearYou(event);
			
		},
		
		_handleSetCurrentIterationClick: function(event){
			dojo.stopEvent(event);
			var store = this._model.store;
			var iteration = this._timelineTree.getFocusedItem();
			if (iteration !== null && store.isIteration(iteration)) {
				store.setCurrentIteration(iteration);
				this.editor.setDirty(this.editor.changesPending());
				this._timelineTree.focusItem(iteration);
			}
			
		},
		
		_handleSetProjectTimeLineClick: function(event){
			dojo.stopEvent(event);
			var store = this._model.store;
			var timeline = this._timelineTree.getFocusedItem();
			if (timeline !== null && store.isTimeline(timeline)) {
				store.setProjectTimeline(timeline);
				this.editor.setDirty(this.editor.changesPending());
				this._timelineTree.focusItem(timeline);
			}
		},
		
		_handleMoveIterationClick: function(event){
			dojo.stopEvent(event);
			this.comingToAComputerNearYou();
		},
		
		comingToAComputerNearYou: function(){
			alert("Coming to a computer near you summer 2009. Beat the crowds and buy your tickets now online!"); //$NON-NLS-1$
		},
		
		_handleCreateTimelineClick: function(event){
		
			var initialValues = [];
			initialValues.push(this.messages.TimelineDialog_NewTimelineDefaultId);
			initialValues.push(this.messages.TimelineDialog_NewTimelineDefaultName);
			initialValues.push(new Date());
			initialValues.push(ProcessConstants.EMPTY);
			
			var dialogWidget = this._createTimelineDialog({
				initialValues: initialValues,
				isProjectTimeline: false,
				isNewTimeline: true,
				primaryTitle: this.messages.TimelineDialog_CreateTimelineTitle
			});
			var timelineDialog = dialogWidget.timelineDialog;
			var self = this;
			this._connectHandles.push(dojo.connect(timelineDialog.finishButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				var timeline = {
					id: timelineDialog.identifier.attr('value'), //$NON-NLS-1$
					name: timelineDialog.displayName.attr('value'), //$NON-NLS-1$
					startDate: timelineDialog.startDate.attr('value'), //$NON-NLS-1$
					endDate: timelineDialog.endDate.attr('value'), //$NON-NLS-1$
					projectTimeline: timelineDialog.projectTimelineCheckBox.checked
				};
				var newTimeline = self._timelineTree.addNewTimeline(timeline);
				self.editor.setDirty(self.editor.changesPending());
				this.close();
				self._timelineTree.focusItem(newTimeline);
			}));
			
			timelineDialog.identifier.focus();
			
		},
		
		_editTimeline: function(timelineToEdit){
		
			var store = this._timelineTree.model.store;
			var initialValues = [];
			initialValues.push(store.getValue(timelineToEdit, "contextId")); //$NON-NLS-1$
			initialValues.push(store.getValue(timelineToEdit, "name")); //$NON-NLS-1$
			initialValues.push(store.getValue(timelineToEdit, "startDate")); //$NON-NLS-1$
			initialValues.push(store.getValue(timelineToEdit, "endDate")); //$NON-NLS-1$
			var dialogWidget = this._createTimelineDialog({
				initialValues: initialValues,
				isProjectTimeline: store.getValue(timelineToEdit, "projectTimeline"), //$NON-NLS-1$,
				isNewTimeline: false,
				primaryTitle: this.messages.TimelineDialog_EditTimelineTitle
			});
			var self = this;
			var timelineDialog = dialogWidget.timelineDialog;
			this._connectHandles.push(dojo.connect(timelineDialog.finishButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (timelineDialog.changesPending()) {
					store.updateTimeline(timelineToEdit, {
						contextId: timelineDialog.identifier.attr('value'), //$NON-NLS-1$ //$NON-NLS-2$
						name: timelineDialog.displayName.attr('value'), //$NON-NLS-1$ //$NON-NLS-2$
						startDate: timelineDialog.startDate.attr('value'), //$NON-NLS-1$ //$NON-NLS-2$
						endDate: timelineDialog.endDate.attr('value'), //$NON-NLS-1$ //$NON-NLS-2$
						projectTimeline: timelineDialog.projectTimelineCheckBox.checked
					});
					self.editor.setDirty(self.editor.changesPending());
				}
				this.close();
				self._timelineTree.focusItem(timelineToEdit);
			}));
			
			if (!this._timelineTree.isNewItem(timelineToEdit)) {
				// Temporarily disabled on existing timelines until back end support
				// is added to make the changes in the config XML
				timelineDialog.identifier.attr('disabled', true); //$NON-NLS-1$
				timelineDialog.displayName.focus();
			} else {
				timelineDialog.identifier.focus();
			}
			
			
		},
		
		_createTimelineDialog: function(dialogArgs){
			var timelineDialog = new com.ibm.team.process.web.ui.internal.admin.projects.TimelineDialog({
				initialValues: dialogArgs.initialValues,
				isProjectTimeline: dialogArgs.isProjectTimeline,
				isNewTimeline: dialogArgs.isNewTimeline
			});
			
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: dialogArgs.primaryTitle,
				contentNode: timelineDialog.domNode,
				// IE can't auto compute the size based on the width of the children
				width: dojo.isIE ? "27em" : ProcessConstants.EMPTY, //$NON-NLS-1$
				destroyContents: true
			});
			dialogWidget.timelineDialog = timelineDialog;
			timelineDialog.startup();
			this._connectHandles.push(dojo.connect(timelineDialog.cancelButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			return dialogWidget;
		},
		
		_createIterationDialog: function(dialogArgs){
			var iterationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.IterationDialog(dialogArgs);
			
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: dialogArgs.primaryTitle,
				contentNode: iterationDialog.domNode,
				// IE can't auto compute the size based on the width of the children
				width: dojo.isIE ? "27em" : ProcessConstants.EMPTY, //$NON-NLS-1$
				destroyContents: true
			});
			dialogWidget.iterationDialog = iterationDialog;
			iterationDialog.startup();
			this._connectHandles.push(dojo.connect(iterationDialog.cancelButton, "onclick", dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			return dialogWidget;
		},
		
		aboutToBeSaved: function(saveObj){
			var self = this;
			var dirtyTimelines = [];
			this._model.store.fetch({
				query: {
					enabledContext: ProcessConstants.PermissionContext.DEV_LINE
				},
				queryOptions: {
					deep: true
				},
				onComplete: dojo.hitch(this._model.store, function(items){
					for (var i = 0; i < items.length; i++) {
						var item = items[i];
						if (this.isDirty(item)) {
							var dirtyTimeline = {};
							dirtyTimeline.itemId = this.getIdentity(item);
							dirtyTimeline.stateId = this.getValue(item, "stateId"); //$NON-NLS-1$
							dirtyTimeline.id = this.getValue(item, "contextId"); //$NON-NLS-1$
							dirtyTimeline.name = this.getValue(item, "name"); //$NON-NLS-1$
							if (this.hasAttribute(item, "startDate")) { //$NON-NLS-1$
								var startDate = this.getValue(item, "startDate"); //$NON-NLS-1$
								if (startDate) {
									dirtyTimeline.startDate = dojo.date.stamp.toISOString(startDate, {
										milliseconds: true,
										zulu: true
									});
								}
							}
							if (this.hasAttribute(item, "endDate")) { //$NON-NLS-1$
								var endDate = this.getValue(item, "endDate"); //$NON-NLS-1$
								if (endDate) {
									dirtyTimeline.endDate = dojo.date.stamp.toISOString(endDate, {
										milliseconds: true,
										zulu: true
									});
								}
							}
							dirtyTimeline.projectTimeline = this.getValue(item, "projectTimeline"); //$NON-NLS-1$
							dirtyTimelines.push(dojo.toJson(dirtyTimeline));
						}
					}
				})
			});
			saveObj.jsonTimelines = dirtyTimelines;
			
			var dirtyIterations = [];
			this._model.store.fetch({
				query: {
					enabledContext: ProcessConstants.PermissionContext.ITERATION
				},
				queryOptions: {
					deep: true
				},
				onComplete: dojo.hitch(this._model.store, function(items){
					for (var i = 0; i < items.length; i++) {
						var item = items[i];
						if (this.isDirty(item)) {
							var dirtyIteration = {};
							var parent = this.getParent(item);
							var timeline = this.getTimelineForIteration(item);
							dirtyIteration.itemId = this.getIdentity(item);
							dirtyIteration.stateId = this.getValue(item, "stateId"); //$NON-NLS-1$
							dirtyIteration.timelineItemId = this.getIdentity(timeline);
							dirtyIteration.timelineStateId = this.getValue(timeline, "stateId"); //$NON-NLS-1$
							dirtyIteration.parentItemId = this.getIdentity(parent);
							dirtyIteration.parentStateId = this.getValue(parent, "stateId"); //$NON-NLS-1$
							dirtyIteration.iterationTypeItemId = this.getValue(item, "iterationTypeItemId"); //$NON-NLS-1$
							dirtyIteration.id = self._timelineTree.getIterationId(this.getValue(item, "contextId")); //$NON-NLS-1$
							dirtyIteration.name = this.getValue(item, "name"); //$NON-NLS-1$
							dirtyIteration.hasDeliverable = this.getValue(item, "hasDeliverable"); //$NON-NLS-1$
							if (this.hasAttribute(item, "startDate")) { //$NON-NLS-1$
								var startDate = this.getValue(item, "startDate"); //$NON-NLS-1$
								if (startDate) {
									dirtyIteration.startDate = dojo.date.stamp.toISOString(startDate, {
										milliseconds: true,
										zulu: true
									});
								}
							}
							if (this.hasAttribute(item, "endDate")) { //$NON-NLS-1$
								var endDate = this.getValue(item, "endDate"); //$NON-NLS-1$
								if (endDate) {
									dirtyIteration.endDate = dojo.date.stamp.toISOString(endDate, {
										milliseconds: true,
										zulu: true
									});
								}
							}
							dirtyIteration.current = this.isCurrentIteration(item);
							dirtyIterations.push(dojo.toJson(dirtyIteration));
						}
					}
				})
			});
			saveObj.jsonIterations = dirtyIterations;
			
		},
		
		saved: function(){
			this._model.store.save();
			
		},
		
		_disconnectHandles: function(){
			dojo.forEach(this._connectHandles, function(handle){
				dojo.disconnect(handle);
			});
			this._connectHandles = [];
		},
		
		uninitialize: function(){
			this.editor.removeSaveParticipant("com.ibm.team.process.web.ui.internal.admin.projects.TimelineEditor"); //$NON-NLS-1$
			this._disconnectHandles();
			if (this._timelineTree) {
				this._timelineTree.destroyRecursive();
				delete this._timelineTree;
			}
			delete this.editor;
			delete this._model;
			this.inherited(arguments);
		}
		
	});
	
})();
